//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "qwwnavigationbariface.h"
#include "qwwnavigationbar.h"

#include <QtDesigner/QExtensionManager>
#include <QtDesigner/QDesignerFormEditorInterface>
#include <QtDesigner/QDesignerFormWindowInterface>
#include <QtDesigner/QDesignerContainerExtension>
#include <QtDesigner/QDesignerPropertySheetExtension>

#include "wwwidgets.h"


QwwNavigationBarIface::QwwNavigationBarIface(QObject *parent)
        : QObject(parent), QDesignerCustomWidgetInterface() {
    initialized = false;
}


QwwNavigationBarIface::~QwwNavigationBarIface() {}




bool QwwNavigationBarIface::isInitialized() const {
    return initialized;
}
QIcon QwwNavigationBarIface::icon() const {
    return QPixmap(":/trolltech/formeditor/images/widgets/toolbox.png");
}

QString QwwNavigationBarIface::includeFile() const {
    return "qwwnavigationbar.h";
}

QString QwwNavigationBarIface::toolTip() const {
    return "";
}

QString QwwNavigationBarIface::whatsThis() const {
    return "";
}

void QwwNavigationBarIface::initialize(QDesignerFormEditorInterface * formEditor) {
    if (initialized)
        return;

    QExtensionManager *manager = formEditor->extensionManager();
    QExtensionFactory *factory = new QwwWidgetsExtensionFactory(manager);

    Q_ASSERT(manager != 0);
    manager->registerExtensions(factory, Q_TYPEID(QDesignerContainerExtension));

    initialized = true;


}

QWidget * QwwNavigationBarIface::createWidget(QWidget * parent) {
    QwwNavigationBar *bar = new QwwNavigationBar(parent);
    connect(bar, SIGNAL(currentIndexChanged(int)),
            this, SLOT(currentIndexChanged(int)));
    connect(bar, SIGNAL(widgetLabelChanged(const QString &)),
            this, SLOT(widgetLabelChanged(const QString &)));
    connect(bar, SIGNAL(widgetIconChanged(const QIcon &)),
            this, SLOT(widgetIconChanged(const QIcon&)));
    return bar;
}


QwwNavigationBarContainerExtension::QwwNavigationBarContainerExtension(QwwNavigationBar *widget,
        QObject *parent)
        :QObject(parent) {
    myWidget = widget;
}

void QwwNavigationBarContainerExtension::addWidget(QWidget *widget) {
    myWidget->addWidget(widget);
}

int QwwNavigationBarContainerExtension::count() const {
    return myWidget->widgetCount();
}

int QwwNavigationBarContainerExtension::currentIndex() const {
    return myWidget->currentIndex();
}

void QwwNavigationBarContainerExtension::insertWidget(int index, QWidget *widget) {
    myWidget->insertWidget(index, widget);
}

void QwwNavigationBarContainerExtension::remove(int index) {
    myWidget->removeWidget(index);
}

void QwwNavigationBarContainerExtension::setCurrentIndex(int index) {
    myWidget->setCurrentIndex(index);
}

QWidget* QwwNavigationBarContainerExtension::widget(int index) const {
    return myWidget->widget(index);

}

QString QwwNavigationBarIface::domXml() const {
    return QString("\
                   <widget class=\"QwwNavigationBar\" name=\"navigationBar\">\
                   <widget class=\"QWidget\" name=\"page\" />\
                   </widget>\
                   ");
}

void QwwNavigationBarIface::widgetIconChanged(const QIcon & icon)
{
    QwwNavigationBar *widget = qobject_cast<QwwNavigationBar*>(sender());
    if (widget) {
        QWidget *page = widget->widget(widget->currentIndex());
        QDesignerFormWindowInterface *form;
        form = QDesignerFormWindowInterface::findFormWindow(widget);
        if (form) {
            QDesignerFormEditorInterface *editor = form->core();
            QExtensionManager *manager = editor->extensionManager();
            QDesignerPropertySheetExtension *sheet;
            sheet = qt_extension<QDesignerPropertySheetExtension*>(manager, page);
            int propertyIndex = sheet->indexOf(QLatin1String("windowIcon"));
            sheet->setChanged(propertyIndex, true);
        }
    }
}

void QwwNavigationBarIface::widgetLabelChanged(const QString & title)
{
    QwwNavigationBar *widget = qobject_cast<QwwNavigationBar*>(sender());
    if (widget) {
        QWidget *page = widget->widget(widget->currentIndex());
        QDesignerFormWindowInterface *form;
        form = QDesignerFormWindowInterface::findFormWindow(widget);
        if (form) {
            QDesignerFormEditorInterface *editor = form->core();
            QExtensionManager *manager = editor->extensionManager();
            QDesignerPropertySheetExtension *sheet;
            sheet = qt_extension<QDesignerPropertySheetExtension*>(manager, page);
            int propertyIndex = sheet->indexOf(QLatin1String("windowTitle"));
            sheet->setChanged(propertyIndex, true);
        }
    }
}

void QwwNavigationBarIface::currentIndexChanged(int index)
{
    QwwNavigationBar *widget = qobject_cast<QwwNavigationBar*>(sender());
    if (widget) {
        QDesignerFormWindowInterface *form;
        form = QDesignerFormWindowInterface::findFormWindow(widget);
        if (form)
            form->emitSelectionChanged();
    }
}

