//
// C++ Interface: qwwnavigationbariface
//
// Description:
//
//
// Author: Witold Wysota <wysota@wysota.eu.org>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef QWWNAVIGATIONBARIFACE_H
#define QWWNAVIGATIONBARIFACE_H

#include <QObject>
#include <QDesignerCustomWidgetInterface>


#include <QtDesigner/QDesignerContainerExtension>
#include "qwwnavigationbar.h"


/**
	@author Witold Wysota <wysota@wysota.eu.org>
*/
class QwwNavigationBarIface : public QObject, public QDesignerCustomWidgetInterface
{
    Q_OBJECT
    Q_INTERFACES(QDesignerCustomWidgetInterface);
public:
    QwwNavigationBarIface(QObject *parent = 0);

    ~QwwNavigationBarIface();
    bool isContainer() const {
        return true;
    }
    bool isInitialized() const;
    QIcon icon() const;
    QString group() const {
        return "wwWidgets";
    }
    QString includeFile() const;
    QString name() const {
        return "QwwNavigationBar";
    }
    QString toolTip() const;
    QString domXml() const;
    QString whatsThis() const;
    QWidget *createWidget(QWidget *parent);
    void initialize(QDesignerFormEditorInterface *core);
private slots:
     void currentIndexChanged(int index);
     void widgetLabelChanged(const QString &title);
     void widgetIconChanged(const QIcon &icon);
private:
    bool initialized;
};



class QwwNavigationBarContainerExtension: public QObject,
                                          public QDesignerContainerExtension
 {
     Q_OBJECT
     Q_INTERFACES(QDesignerContainerExtension);

 public:
     QwwNavigationBarContainerExtension(QwwNavigationBar *widget, QObject *parent);

     void addWidget(QWidget *widget);
     int count() const;
     int currentIndex() const;
     void insertWidget(int index, QWidget *widget);
     void remove(int index);
     void setCurrentIndex(int index);
     QWidget *widget(int index) const;

 private:
     QwwNavigationBar *myWidget;
 };


#endif
