//
// C++ Interface: qwwtaskpaneliface
//
// Description:
//
//
// Author: Witold Wysota <wysota@wysota.eu.org>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef QWWTASKPANELIFACE_H
#define QWWTASKPANELIFACE_H
#ifndef WW_NO_TASKPANEL
#include <QObject>
#include <QDesignerCustomWidgetInterface>
#include <QtDesigner/QDesignerContainerExtension>
#include <QtDesigner/QDesignerPropertySheetExtension>
#include <QTimer>
#include <QVariant>

#include "qwwtaskpanel.h"


class QwwTaskPanelIface : public QObject, public QDesignerCustomWidgetInterface {
    Q_OBJECT
    Q_INTERFACES(QDesignerCustomWidgetInterface);
public:
    QwwTaskPanelIface(QObject *parent = 0);

    ~QwwTaskPanelIface();
    bool isContainer() const {
        return true;
    }
    bool isInitialized() const {
        return m_initialized;
    }
    QIcon icon() const;
    QString domXml() const;
    QString group() const {
        return "wwWidgets";
    }
    QString includeFile() const;
    QString name() const {
        return "QwwTaskPanel";
    }
    QString toolTip() const {
        return "";
    }
    QString whatsThis() const {
        return "";
    }
    QWidget *createWidget(QWidget *parent);
    void initialize(QDesignerFormEditorInterface *core);
private:
    bool m_initialized;
    bool eventFilter(QObject *obj, QEvent *e);
    QDesignerFormEditorInterface *formEditor;
private slots:
    void currentIndexChanged(int);
    void execute();
};


class QwwTaskPanelContainerExtension: public QObject,
            public QDesignerContainerExtension {
    Q_OBJECT
    Q_INTERFACES(QDesignerContainerExtension);

public:
    QwwTaskPanelContainerExtension(QwwTaskPanel *widget, QObject *parent);

    void addWidget(QWidget *widget);
    int count() const;
    int currentIndex() const;
    void insertWidget(int index, QWidget *widget);
    void remove(int index);
    void setCurrentIndex(int index);
    QWidget *widget(int index) const;

private:
    QwwTaskPanel *myWidget;
};

class PropertyMatcher;

class QwwTaskPanelSheetExtension : public QObject,
         public QDesignerPropertySheetExtension
 {
     Q_OBJECT
     Q_INTERFACES(QDesignerPropertySheetExtension);

 public:
    QwwTaskPanelSheetExtension(QWidget *w, QObject *other, QObject *parent=0);
    ~QwwTaskPanelSheetExtension();
    int count () const;
    bool hasReset ( int index ) const;
    int indexOf ( const QString & name ) const;
    bool isAttribute ( int index ) const;
    bool isChanged ( int index ) const;
    bool isVisible ( int index ) const;
    QVariant property ( int index ) const;
    QString propertyGroup ( int index ) const;
    QString propertyName ( int index ) const;
    bool reset ( int index );
    void setAttribute ( int index, bool attribute );
    void setChanged ( int index, bool changed );
    void setProperty ( int index, const QVariant & value );
    void setPropertyGroup ( int index, const QString & group );
    void setVisible ( int index, bool visible );
private:
  int myindex;
  QDesignerPropertySheetExtension *m_other;
  QwwTaskPanel *m_panel;
  void setPropertyChanged(QWidget *task, const QString &propName, const QVariant &value=QVariant());
//   PropertyMatcher *m_matcher;
 };

#endif
#endif
