//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include <QtDesigner/QtDesigner>
#include <QtCore/qplugin.h>

#include "wwwidgets.h"
#include "qwwlineeditiface.h"
#include "qwwtipwidgetiface.h"
#include "qwwlistwidgetiface.h"
#include "qwwlongspinboxiface.h"
#include "qwwtwocolorindicatoriface.h"
#include "qwwcolorcomboboxiface.h"
#include "qwwnavigationbariface.h"
#include "qwwnumpadiface.h"
#include "qwwcolorbuttoniface.h"
#include "qwwtaskpaneliface.h"
#include "qwwhuesatpickeriface.h"
#include "qwwhuesatradialpickeriface.h"

#include <QMutex>
QMutex cheatmutex;

wwWidgets::wwWidgets(QObject *parent)
        : QObject(parent), QDesignerCustomWidgetCollectionInterface() {
    widgets << new QwwLineEditIface(this);
    widgets << new QwwTipWidgetIface(this);
    widgets << new QwwListWidgetIface(this);
#ifndef WW_NO_SPINBOX
    widgets << new QwwLongSpinBoxIface(this);
#endif
    widgets << new QwwTwoColorIndicatorIface(this);
#ifndef WW_NO_COLORCOMBOBOX
    widgets << new QwwColorComboBoxIface(this);
#endif
    widgets << new QwwNavigationBarIface(this);
    widgets << new QwwNumPadIface(this);
    widgets << new QwwColorButtonIface(this);
#ifndef WW_NO_TASKPANEL
    widgets << new QwwTaskPanelIface(this);
#endif
    widgets << new QwwHueSatPickerIface(this);
    widgets << new QwwHueSatRadialPickerIface(this);
}

QList< QDesignerCustomWidgetInterface * > wwWidgets::customWidgets( ) const {
    return widgets;
}

Q_EXPORT_PLUGIN2(wwwidgets, wwWidgets)


void wwWidgetsMenu::about() {
    QDialog dlg;
    Ui::About ui;
    ui.setupUi(&dlg);
    dlg.setFixedSize(dlg.sizeHint());
    dlg.exec();
}

wwWidgetsMenu::wwWidgetsMenu(const QString & title, QWidget * parent) : QMenu(title, parent) {
    addAction("About", this, SLOT(about()));
}


QwwWidgetsExtensionFactory::QwwWidgetsExtensionFactory(QExtensionManager *manager ) {
    m_manager = manager;
}


QObject * QwwWidgetsExtensionFactory::createExtension(QObject * object, const QString & iid, QObject * parent) const {


    if (iid == Q_TYPEID(QDesignerContainerExtension)) {
        #ifndef WW_NO_TASKPANEL
        if (QwwTaskPanel *widget = qobject_cast<QwwTaskPanel*>(object) ) {
            return new QwwTaskPanelContainerExtension(widget, parent);
        } else
        #endif
        if (QwwNavigationBar *widget = qobject_cast<QwwNavigationBar*>(object)) {
            return new QwwNavigationBarContainerExtension(widget, parent);
        }
    } else if (iid == Q_TYPEID(QDesignerPropertySheetExtension)) {
        if (cheatmutex.tryLock()) {
            #ifndef WW_NO_TASKPANEL
            if (QwwTaskPanel *widget = qobject_cast<QwwTaskPanel*>(object) ) {
                QObject *otherExtension = m_manager->extension(object, iid);
                cheatmutex.unlock();
                return new QwwTaskPanelSheetExtension(widget, otherExtension, parent);
            }
            #endif
            cheatmutex.unlock();
        }
    }
    return 0;
}

