//
// C++ Interface: qcolorbutton
//
// Description:
//
//
// Author: Witold Wysota <wysota@wysota.eu.org>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef QWWCOLORBUTTON_H
#define QWWCOLORBUTTON_H

#ifndef WW_NO_COLORBUTTON

#include <QPushButton>
#include <QModelIndex>
#include <wwglobal.h>


class QwwColorButtonPrivate;
class Q_WW_EXPORT QwwColorButton : public QPushButton, public QwwPrivatable {
    Q_OBJECT
    Q_PROPERTY(QList<QColor> colors READ colors WRITE setColors)
    Q_PROPERTY(QColor currentColor READ currentColor WRITE setCurrentColor)
public:
    QwwColorButton(QWidget *parent = 0);
    QColor currentColor() const;
    void addColor(const QColor &c, const QString &n = QString::null);
    void setStandardColors();
    void clear();
    ~QwwColorButton();
    QList<QColor> colors() const;
    void setColors(const QList<QColor> &);
public slots:
    void setCurrentColor(const QColor &c);
signals:
    void colorPicked(QColor);
private:
    WW_DECLARE_PRIVATE(QwwColorButton);
private slots:
    void _q_clicked();
    void _q_activated(const QModelIndex &);
    void _q_colorDialogRequested();
    void _q_setCurrentIndex(const QModelIndex &);
};

#endif // WW_NO_COLORBUTTON

#endif // QWWCOLORBUTTON_H
