//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef WW_NO_COLORCOMBOBOX

#include "qwwcolorcombobox.h"
#include <QItemDelegate>
#include <QColorDialog>
#include <QAbstractItemView>
#include <QMessageBox>
#include <QLayout>
#include <QPushButton>
#include <QEvent>

/**
 *  @class QwwColorComboBox
 *  @brief Combobox that allows to pick colors. (unstable)
 *
 */


QwwColorComboBox::QwwColorComboBox(QWidget *parent)
        : QComboBox(parent) {
    connect(this, SIGNAL(highlighted(int)), this, SLOT(_q_highlighted(int)));
    connect(this, SIGNAL(activated(int)), this, SLOT(w_q_activated(int)));
    connect(this, SIGNAL(currentIndexChanged(int)), this, SLOT(_q_currentIndexChanged(int)));
    view()->installEventFilter(this);
    connect(view(), SIGNAL(clicked(const QModelIndex &)), SLOT(_q_popup(const QModelIndex&)));
    m_dlgEnabled = false;
//       addColor(Qt::red, "xx");

}


QwwColorComboBox::~QwwColorComboBox() {}

void QwwColorComboBox::addColor(const QColor & color, const QString & name) {
    insertColor(colorCount(), color, name);
}

void QwwColorComboBox::setCurrentColor(const QColor & color) {
    int i = findData(color);
    if (i!=-1) {
        setCurrentIndex(i);
    }
}


void QwwColorComboBox::insertColor(int index, const QColor & color, const QString & name) {
    QPixmap px(12, 12);
    px.fill(color);
    insertItem(index, QIcon(px), name, color);
}

QColor QwwColorComboBox::currentColor() const {
    return QColor();
}

int QwwColorComboBox::colorCount() const {
    return /*m_dlgEnabled ? count()-1 :*/ count();
}

QColor QwwColorComboBox::color(int index) const {
    return QColor();
}

void QwwColorComboBox::setStandardColors() {}


bool QwwColorComboBox::isColorDialogEnabled() const {
    return m_dlgEnabled;
}

void QwwColorComboBox::setColorDialogEnabled(bool enabled) {
    if (m_dlgEnabled == enabled) return;
    m_dlgEnabled = enabled;
//     if(enabled){
//         addItem("More...");
//     } else {
//         removeItem(count()-1);
//     }
}



void QwwColorComboBox::_q_currentIndexChanged(int i) {
    QVariant v = itemData(i, Qt::UserRole);
    if (v.isValid()) {
        QColor c = qvariant_cast<QColor>(v);
        if (c.isValid()) {
            emit currentIndexChanged(c);
        }
    }
}

void QwwColorComboBox::w_q_activated(int i) {
//     QMessageBox::information(this, "", "ACTIVATED");

//     if (m_dlgEnabled && i==count()-1) {
//         popupDialog();
//         return;
//     }
    QVariant v = itemData(i, Qt::UserRole);
    if (v.isValid()) {
        QColor c = qvariant_cast<QColor>(v);
        if (c.isValid())
            emit activated(c);

    }
}

void QwwColorComboBox::_q_highlighted(int i) {
//     QMessageBox::information(this, "BLAD", "HIGHLIGHTED");
    qDebug("HIGHLIGHTED: %d", i);
    QVariant v = itemData(i, Qt::UserRole);
    if (v.isValid()) {
        QColor c = qvariant_cast<QColor>(v);
        if (c.isValid())
            emit highlighted(c);
    }
}

void QwwColorComboBox::showPopup() {

    if (m_dlgEnabled)
        addItem("More");
    QComboBox::showPopup();
}

void QwwColorComboBox::popupDialog() {
    QColor newcol = QColorDialog::getColor(Qt::white, this);
    if (newcol.isValid()) {
        insertColor(count()-1, newcol, "Custom color");
        setCurrentIndex(count()-2);
    }
}

void QwwColorComboBox::_q_popup(const QModelIndex &ind) {
    QMessageBox::information(this, "POPUP", "POP");
    if (ind.row()==ind.model()->rowCount()-1) {
        popupDialog();
    }
}

bool QwwColorComboBox::eventFilter(QObject * o, QEvent * e) {
    if (o==view() && e->type()==QEvent::Hide) {
        if (m_dlgEnabled) {
            removeItem(count()-1);
        }
    }
    return QComboBox::eventFilter(o, e);
}

#endif
