//
// C++ Interface: qwwcolorcombobox
//
// Description:
//
//
// Author: Witold Wysota <wysota@wysota.eu.org>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef QWWCOLORCOMBOBOX_H
#define QWWCOLORCOMBOBOX_H

#ifndef WW_NO_COLORCOMBOBOX

#include <QComboBox>
#include <QModelIndex>
#include <wwglobal.h>

/**
 *
 *
 *
 */
class Q_WW_EXPORT QwwColorComboBox : public QComboBox {
    Q_OBJECT
    Q_PROPERTY(bool colorDialogEnabled READ isColorDialogEnabled WRITE setColorDialogEnabled)
public:
    QwwColorComboBox(QWidget *parent = 0);
    ~QwwColorComboBox();
    void addColor ( const QColor & color, const QString & name );
    QColor color ( int index ) const;
    int colorCount () const;
    QColor currentColor () const;
    void insertColor ( int index, const QColor & color, const QString & name );
    bool isColorDialogEnabled () const;
    void setColorDialogEnabled ( bool enabled = true );

    void setStandardColors ();
    void showPopup();
public slots:
    void setCurrentColor ( const QColor & color );
signals:
    void activated(const QColor &);
    void currentIndexChanged(const QColor &);
    void highlighted(const QColor &);
    void debug(const QString &);
protected:
    bool eventFilter(QObject *o, QEvent *e);
private:
    bool m_dlgEnabled;
private slots:
    void _q_highlighted(int);
    void w_q_activated(int);
    void _q_currentIndexChanged(int);
    void _q_popup(const QModelIndex &);

    void popupDialog();
};

#endif
#endif
