//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef WW_NO_LINEEDIT

#include "qwwlineedit.h"
#include <QRegExpValidator>

/**
 *
 * @param parent
 */
QwwLineEdit::QwwLineEdit(QWidget *parent)
        : QLineEdit(parent) {}


/**
 *
 * @param contents
 * @param parent
 */
QwwLineEdit::QwwLineEdit(const QString & contents, QWidget * parent)
        : QLineEdit(contents, parent) {}

/**
 *
 */
QwwLineEdit::~QwwLineEdit() {}


/**
 *
 * @return
 */
QString QwwLineEdit::regExp() const {
    const QRegExpValidator *rxvalid = qobject_cast<const QRegExpValidator*>(validator());
    if (!rxvalid) return ".*";
    return rxvalid->regExp().pattern();
}

/**
 * @brief   Sets \a v as a regular expression validator
 * @param v regular expression to set
 */
void QwwLineEdit::setRegExp(const QString &v) {
    QValidator *valid = const_cast<QValidator*>(validator());
    QRegExpValidator *rxvalid = qobject_cast<QRegExpValidator*>(valid);
    if (rxvalid && rxvalid->regExp().pattern()==v) {
        return;
    }
    QRegExp rx(v);
    if (v==".*" || v.isEmpty()) {
        setValidator(0);
        emit validatorChanged(".*");
        return;
    }
    if (rxvalid) {
        rxvalid->setRegExp(rx);
    } else {
        setValidator(new QRegExpValidator(rx, this));
    }
    emit validatorChanged(v);
}

/**
 *
 * @param rx
 */
void QwwLineEdit::setRegExp(const QRegExp &rx) {
    QValidator *valid = const_cast<QValidator*>(validator());
    QRegExpValidator *rxvalid = qobject_cast<QRegExpValidator*>(valid);
    if (rxvalid && rxvalid->regExp()==rx) {
        return;
    }
    if (rx.pattern()==".*") {
        setValidator(0);
        emit validatorChanged(".*");
        return;
    }
    if (rxvalid) {
        rxvalid->setRegExp(rx);
    } else {
        setValidator(new QRegExpValidator(rx, this));
    }
    emit validatorChanged(rx.pattern());
}

#endif
