//
// C++ Interface: qwwlineedit
//
// Description:
//
//
// Author: Witold Wysota <wysota@wysota.eu.org>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef QWWLINEEDIT_H
#define QWWLINEEDIT_H

#include <QLineEdit>
#include <wwglobal.h>

/**
 *  @brief QLineEdit with regular expression validation support
 *
 *
 */
class Q_WW_EXPORT QwwLineEdit : public QLineEdit
{
Q_OBJECT
Q_PROPERTY(QString regExp READ regExp WRITE setRegExp USER true)
public:
    QwwLineEdit(QWidget *parent = 0);
    QwwLineEdit ( const QString & contents, QWidget * parent = 0 );
    ~QwwLineEdit();
    QString regExp() const;
signals:
    void validatorChanged(const QString&);
public slots:
    void setRegExp(const QString &);
    void setRegExp(const QRegExp &);
};

#endif
