//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef WW_NO_LISTWIDGET

#include "qwwlistwidget.h"

/**
 *  @class QwwListWidget
 *  @brief An enhanced QListWidget
 *
 *
 */

/**
 *
 * @param parent
 */
QwwListWidget::QwwListWidget(QWidget *parent) : QListWidget(parent) {
    connect(this, SIGNAL(currentItemChanged(QListWidgetItem*, QListWidgetItem*)), SLOT(curCh(QListWidgetItem*)));
}

/**
 *  @brief  Moves current item one row down if possible
 */
void QwwListWidget::moveCurrentDown() {
    int pos = currentRow();
    if (pos==count()-1) return;
    QListWidgetItem *item = takeItem(pos);
    insertItem(pos+1, item);
    setCurrentItem(item);
}

/**
 *  @brief  Moves current item one row up if possible
 */
void QwwListWidget::moveCurrentUp() {
    int pos = currentRow();
    if (pos==0) return;
    QListWidgetItem *item = takeItem(pos);
    insertItem(pos-1, item);
    setCurrentItem(item);
}

/**
 *  @brief  Removes current item from the list
 */
void QwwListWidget::removeCurrent() {
    QListWidgetItem *item = currentItem();
    delete item;
    emit currentAvailable(currentItem()!=0);
}

/**
 *
 * @param i
 */
void QwwListWidget::curCh(QListWidgetItem * i) {
    emit currentAvailable(i!=0);
}

#endif
